import { resolver } from '../resolver';
var preact = require('preact');
var oldHandler = preact.options.vnode;
function patchReact(preact) {
    preact.options.vnode = function (vnode) {
        var type = vnode.nodeName, props = vnode.attributes, args = vnode.children;
        var resolved = resolver(type, props, args);
        var node = vnode;
        if (resolved) {
            var _a = resolved.type, newType = _a === void 0 ? type : _a, _b = resolved.props, newProps = _b === void 0 ? props : _b, _c = resolved.children, children = _c === void 0 ? args : _c;
            node = {
                nodeName: newType,
                arguments: newProps,
                children: newProps && newProps.children || children,
            };
        }
        return oldHandler
            ? oldHandler(node)
            : node;
    };
}
export var enable = function () { return patchReact(preact); };
export var disable = function () { return preact.options.vnode = oldHandler; };
enable();
